Scriptname _DE_SwimDetectScript_Wet extends activemagiceffect  

GlobalVariable property _DE_SwimState auto
_DE_EPMonitor_1_6 property pMainScript auto
GlobalVariable property _DE_CurrentTemp auto
GlobalVariable property _DE_LastWaterMsgTime auto
GlobalVariable property GameHour auto
GlobalVariable property _DE_ExposurePoints auto
Spell property _DE_ColdWater_1 auto
Spell property _DE_ColdWater_2 auto
Spell property _DE_ColdWater_3 auto
spell property _DE_WetState_Spell1 auto
spell property _DE_WetState_Spell2 auto
spell property _DE_WetState_Spell3 auto
magiceffect property FireCloakFFSelf auto
PlayerVampireQuestScript property VampireQuestRef auto
message property _DE_WaterTemp1 auto
message property _DE_WaterTemp2 auto
message property _DE_WaterTemp3 auto
message property _DE_WaterTemp4 auto
keyword property _DE_WaterPotionKW auto

import debug

Event OnEffectStart(Actor akTarget, Actor akCaster)
	;Player is swimming
	_DE_SwimState.SetValue(1)
	
	;Player is soaking wet
	pMainScript.pWetPoints = 40.0
	
	
	;Remove visual effects while in water
	if Game.GetPlayer().HasSpell(_DE_WetState_Spell1)
		Game.GetPlayer().RemoveSpell(_DE_WetState_Spell1)
	endif
	if Game.GetPlayer().HasSpell(_DE_WetState_Spell2)
		Game.GetPlayer().RemoveSpell(_DE_WetState_Spell2)
	endif
	if Game.GetPlayer().HasSpell(_DE_WetState_Spell3)
		Game.GetPlayer().RemoveSpell(_DE_WetState_Spell3)
	endif
	
	if Game.GetPlayer().IsInInterior()
		;do not affect the player
	elseif pMainScript.pSetting_IsRunning == false
		;do not affect the player if Frostfall isn't running
	elseif Game.GetPlayer().HasMagicEffect(FireCloakFFSelf)
		;do not affect the player if the player is using Flamecloak
	elseif Game.GetPlayer().HasEffectKeyword(_DE_WaterPotionKW)
		;do not affect the player when using the water potion
		;notification("I have the water potion!")
	elseif VampireQuestRef.VampireStatus >= 1
		;do not affect the player if the player is a vampire
	else
		if pMainScript.pSetting_IsRunning == true && pMainScript.ShutdownState == false
			ApplyTempEffects()
		endif
	endif
	
	RegisterForSingleUpdate(3)
endEvent

event OnUpdate()
	if _DE_SwimState.GetValueInt() == 0
		;do nothing
	else
		if Game.GetPlayer().IsInInterior()
			;do not affect the player when in interiors
		elseif pMainScript.pSetting_IsRunning == false
			;do not affect the player if Frostfall isn't running
		elseif Game.GetPlayer().HasMagicEffect(FireCloakFFSelf)
			;do not affect the player when using flamecloak
		elseif Game.GetPlayer().HasEffectKeyword(_DE_WaterPotionKW)
			;do not affect the player when using the water potion
			;notification("I have the water potion!")
		elseif VampireQuestRef.VampireStatus >= 1
			;do not affect the player if a vampire
		else
			if pMainScript.pSetting_IsRunning == true && pMainScript.ShutdownState == false
				ApplyTempEffects()
			endif
		endif
		RegisterForSingleUpdate(3)
	endif
endEvent

function ApplyTempEffects()
	;Check temperature and apply effects as needed
	int iTemp = _DE_CurrentTemp.GetValueInt()
	int waterTemp = iTemp + 2		;Tweak to keep worst conditions out of Tundra (Whiterun) areas
	
	float msgTimeDiff = (GameHour.GetValue() - _DE_LastWaterMsgTime.GetValue())			;CONVERT THIS TO A PROPERTY

	if waterTemp > 10
		;Suppress frequent messages
		
		if msgTimeDiff > 1.0
			_DE_WaterTemp1.Show()
			_DE_LastWaterMsgTime.SetValue(GameHour.GetValue())			;CONVERT THIS TO A PROPERTY
		endif
	elseif waterTemp <= 10 && waterTemp > 5
		if Game.GetPlayer().HasSpell(_DE_ColdWater_1) == false
			Game.GetPlayer().AddSpell(_DE_ColdWater_1, false)
			if _DE_ExposurePoints.GetValue() > 80.0				;Damage the player's current EP
				_DE_ExposurePoints.SetValue(80.0)
			endif
			if msgTimeDiff > 1.0
				_DE_WaterTemp2.Show()
				_DE_LastWaterMsgTime.SetValue(GameHour.GetValue())			;CONVERT THIS TO A PROPERTY
			endif
		endif
	elseif waterTemp <= 5 && waterTemp > 0
		if Game.GetPlayer().HasSpell(_DE_ColdWater_2) == false
			Game.GetPlayer().AddSpell(_DE_ColdWater_2, false)
			if _DE_ExposurePoints.GetValue() > 70.0				;Damage the player's current EP
				_DE_ExposurePoints.SetValue(70.0)
			endif
			if msgTimeDiff > 1.0
				_DE_WaterTemp3.Show()
				_DE_LastWaterMsgTime.SetValue(GameHour.GetValue())			;CONVERT THIS TO A PROPERTY
			endif
		endif
	elseif waterTemp < 0
		if Game.GetPlayer().HasSpell(_DE_ColdWater_3) == false
			Game.GetPlayer().AddSpell(_DE_ColdWater_3, false)
			if _DE_ExposurePoints.GetValue() > 60.0				;Damage the player's current EP
				_DE_ExposurePoints.SetValue(60.0)
			endif
			if msgTimeDiff > 1.0
				_DE_WaterTemp4.Show()
				_DE_LastWaterMsgTime.SetValue(GameHour.GetValue())			;CONVERT THIS TO A PROPERTY
			endif
		endif
	endif
endFunction