Scriptname _DE_TentHideLarge_Packed_ACT_Multi extends ObjectReference
{Script that drives the droppable Tent item for player activation.}

import Message
import debug

;Misc (Inventory) items
MiscObject property _DE_CampTentHideLarge_MISC_20 auto
MiscObject property _DE_CampTentHideLarge_MISC_19 auto
MiscObject property _DE_CampTentHideLarge_MISC_18 auto
MiscObject property _DE_CampTentHideLarge_MISC_17 auto
MiscObject property _DE_CampTentHideLarge_MISC_16 auto
MiscObject property _DE_CampTentHideLarge_MISC_15 auto
MiscObject property _DE_CampTentHideLarge_MISC_14 auto
MiscObject property _DE_CampTentHideLarge_MISC_13 auto
MiscObject property _DE_CampTentHideLarge_MISC_12 auto
MiscObject property _DE_CampTentHideLarge_MISC_11 auto
MiscObject property _DE_CampTentHideLarge_MISC_10 auto
MiscObject property _DE_CampTentHideLarge_MISC_9 auto
MiscObject property _DE_CampTentHideLarge_MISC_8 auto
MiscObject property _DE_CampTentHideLarge_MISC_7 auto
MiscObject property _DE_CampTentHideLarge_MISC_6 auto
MiscObject property _DE_CampTentHideLarge_MISC_5 auto
MiscObject property _DE_CampTentHideLarge_MISC_4 auto
MiscObject property _DE_CampTentHideLarge_MISC_3 auto
MiscObject property _DE_CampTentHideLarge_MISC_2 auto
MiscObject property _DE_CampTentHideLarge_MISC_1 auto

;"Packed" tent activators
Activator property _DE_CampTentHideLarge_Packed_ACT_20 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_19 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_18 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_17 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_16 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_15 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_14 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_13 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_12 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_11 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_10 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_9 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_8 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_7 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_6 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_5 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_4 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_3 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_2 auto
Activator property _DE_CampTentHideLarge_Packed_ACT_1 auto

;"Placed" tent activators
Activator property _DE_CampTentHideLarge_Placed_ACT_20 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_19 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_18 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_17 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_16 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_15 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_14 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_13 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_12 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_11 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_10 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_9 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_8 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_7 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_6 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_5 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_4 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_3 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_2 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_1 auto

Message property _DE_CampTent_MISC_Menu auto
{Reference to the Camp Tent Menu.}

float property myXOffset auto
float property myYOffset auto

Event OnInit()
	;Game.DisablePlayerControls()					;Force the player out of their inventory
	;Game.EnablePlayerControls()
	self.SetScale(2.0)
	self.SetAngle(0.0, 0.0, 0.0)
	GetOffset()
	self.MoveTo(self, myXOffset, myYOffset, 20.0)
	utility.wait(0.5)
	self.ApplyHavokImpulse(0.0, 0.0, -1.0, 1.0)		;Force to fall to the ground, like an item drop
endEvent

Event OnActivate(ObjectReference akActionRef)
       
    int iButton = _DE_CampTent_MISC_Menu.Show()
  
    int iFuncReturn = -1
  
    if iButton == 0
        Tent_Pitch()
    elseif iButton == 1
        Tent_PickUp()
    elseif iButton == 2
        ;do nothing
    endif
endEvent

function Tent_Pitch()
    ;Create the tent at this position
	if self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_20
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_20)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_19
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_19)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_18
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_18)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_17
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_17)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_16
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_16)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_15
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_15)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_14
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_14)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_13
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_13)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_12
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_12)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_11
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_11)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_10
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_10)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_9
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_9)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_8
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_8)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_7
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_7)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_6
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_6)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_5
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_5)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_4
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_4)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_3
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_3)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_2
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_2)
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_1
		self.PlaceAtMe(_DE_CampTentHideLarge_Placed_ACT_1)
	endif
	
    self.Disable(true)
	self.Delete()
endfunction  
       
function Tent_PickUp()
    ;Pick it up
		
	if self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_20
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_20)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_19
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_19)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_18
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_18)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_17
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_17)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_16
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_16)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_15
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_15)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_14
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_14)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_13
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_13)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_12
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_12)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_11
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_11)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_10
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_10)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_9
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_9)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_8
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_8)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_7
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_7)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_6
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_6)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_5
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_5)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_4
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_4)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_3
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_3)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_2
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_2)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTentHideLarge_Packed_ACT_1
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_1)
		self.Disable()
		self.Delete()
	endif
endfunction

function GetOffset()
	;Trigonometry time! We need to position the campsite item such that it is dropped in front of the player.
	int myQuad = 1
	float mySideC = 100.0	;Hypotenuse (distance to move the object forward)
	float myAngleA = Game.GetPlayer().GetAngleZ()
	
	float myAngleC = 90.0
	
	;Clamp to an angle less than 90 degrees.
	if myAngleA > 90.0 && myAngleA <= 180.0
		myAngleA -= 90.0
		myQuad = 2
	elseif myAngleA > 180.0 && myAngleA <= 270.0
		myAngleA -= 180.0
		myQuad = 3
	elseif myAngleA > 270.0
		myAngleA -= 270.0
		myQuad = 4
	endif
	
	;Determine the length of the legs of the triangle for moving the player.
	float mySideA = math.sin(myAngleA) * mySideC				;Y offset
	float mySideB = math.cos(myAngleA) * mySideC				;X offset
	
	;Figure out which direction the offset should travel based on the quadrant.
		
	if myQuad == 1
		;Move farther into the 1st quadrant
		myXOffset = mySideA
		myYOffset = mySideB
	elseif myQuad == 2
		;Move farther into the 2nd quadrant
		myXOffset = mySideA
		myYOffset = mySideB * -1.0
	elseif myQuad == 3
		;Move farther into the 3rd quadrant
		myXOffset = mySideA * -1.0
		myYOffset = mySideB * -1.0
	elseif myQuad == 4
		;Move farther into the 4th quadrant
		myXOffset = mySideA * -1.0
		myYOffset = mySideB
	endif

endFunction
