Scriptname _DE_TentHideLarge_Placed_ACT_Multi extends ObjectReference
{Script that drives the pitched tent.  Allows you to break down the tent.}

import Message
import debug
import utility

;Misc (Inventory) items
MiscObject property _DE_CampTentHideLarge_MISC_20 auto
MiscObject property _DE_CampTentHideLarge_MISC_19 auto
MiscObject property _DE_CampTentHideLarge_MISC_18 auto
MiscObject property _DE_CampTentHideLarge_MISC_17 auto
MiscObject property _DE_CampTentHideLarge_MISC_16 auto
MiscObject property _DE_CampTentHideLarge_MISC_15 auto
MiscObject property _DE_CampTentHideLarge_MISC_14 auto
MiscObject property _DE_CampTentHideLarge_MISC_13 auto
MiscObject property _DE_CampTentHideLarge_MISC_12 auto
MiscObject property _DE_CampTentHideLarge_MISC_11 auto
MiscObject property _DE_CampTentHideLarge_MISC_10 auto
MiscObject property _DE_CampTentHideLarge_MISC_9 auto
MiscObject property _DE_CampTentHideLarge_MISC_8 auto
MiscObject property _DE_CampTentHideLarge_MISC_7 auto
MiscObject property _DE_CampTentHideLarge_MISC_6 auto
MiscObject property _DE_CampTentHideLarge_MISC_5 auto
MiscObject property _DE_CampTentHideLarge_MISC_4 auto
MiscObject property _DE_CampTentHideLarge_MISC_3 auto
MiscObject property _DE_CampTentHideLarge_MISC_2 auto
MiscObject property _DE_CampTentHideLarge_MISC_1 auto
MiscObject property _DE_CampTentHideLarge_MISC_0 auto

;"Placed" tent activators
Activator property _DE_CampTentHideLarge_Placed_ACT_20 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_19 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_18 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_17 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_16 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_15 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_14 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_13 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_12 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_11 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_10 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_9 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_8 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_7 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_6 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_5 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_4 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_3 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_2 auto
Activator property _DE_CampTentHideLarge_Placed_ACT_1 auto

{Reference to the Camp Tent Menu.}
message property _DE_Backpack_MISC_Error_Tent_FallApart auto
message property _DE_CampTent_Placed_ACT_Menu auto


GlobalVariable property _DE_Setting_Tent auto
{Tent durability setting}
GlobalVariable property _DE_CurrentTemp auto
{Current temperature}

;Bed Roll
ObjectReference property myBed auto
Furniture property Bedroll01 auto

;Snowy tent creation
ObjectReference property SnowTent auto
Static property NorTentLargeSnow auto
float property pCreateTime auto
bool property pSnowTentCreated auto

Event OnInit()
	self.SetAngle(0.0, 0.0, Game.GetPlayer().GetAngleZ())
	myBed = self.PlaceAtMe(Bedroll01)
	self.MoveTo(self, 0.0, 0.0, -9.0)
	pCreateTime = GetCurrentGameTime()
	RegisterForUpdate(1)
endEvent

Event OnActivate(ObjectReference akActionRef)
       
    int iButton = _DE_CampTent_Placed_ACT_Menu.Show()
  
    ;What do you want to do?
    ;1: Pack Tent 2: Cancel
  
    if iButton == 0
        Tent_Placed_Destroy()
    elseif iButton == 1
        ;do nothing
    endif
endEvent

Event OnUpdate()
	if pSnowTentCreated == false
		if Weather.GetCurrentWeather() == "[Weather < (0004D7FB)>]" || Weather.GetCurrentWeather() == "[Weather < (000C8221)>]"	;It's snowing right now!
			;Add "snowy" tent on top of current one
			SnowTent = self.PlaceAtMe(NorTentLargeSnow)
			SnowTent.MoveTo(SnowTent, 0.0, 0.0, 0.1)
			pSnowTentCreated = true
		elseif _DE_CurrentTemp.GetValueInt() <= -10								;Player is in snowy terrain
			if GetCurrentGameTime() - pCreateTime > 0.0416					;Wait 1 Hour
				;Add "snowy" tent on top of current one
				SnowTent = self.PlaceAtMe(NorTentLargeSnow)
				SnowTent.MoveTo(SnowTent, 0.0, 0.0, 0.1)
				pSnowTentCreated = true
			endif
		endif
	endif
endEvent

function Tent_Placed_Destroy()
	if _DE_Setting_Tent.GetValueInt() == 1
		;Drives degrading the tent's durability
		if self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_20
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_19)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_19
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_18)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_18
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_17)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_17
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_16)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_16
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_15)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_15
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_14)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_14
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_13)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_13
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_12)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_12
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_11)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_11
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_10)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_10
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_9)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_9
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_8)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_8
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_7)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_7
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_6)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_6
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_5)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_5
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_4)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_4
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_3)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_3
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_2)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_2
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_1)
		elseif self.GetBaseObject() == _DE_CampTentHideLarge_Placed_ACT_1
			Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_0)
			_DE_Backpack_MISC_Error_Tent_FallApart.Show()
		endif	
		
		UnregisterForUpdate()
		SnowTent.disable()
		SnowTent.Delete()
		self.disable(true)
		self.Delete()
		myBed.disable(true)
		myBed.Delete()
	else
		Game.GetPlayer().AddItem(_DE_CampTentHideLarge_MISC_20)
		
		UnregisterForUpdate()
		SnowTent.disable()
		SnowTent.Delete()
		self.disable(true)
		self.Delete()
		myBed.disable(true)
		myBed.Delete()
	endif
endfunction